#!/usr/bin/perl
use strict;
# --------------------------------------------------------------------------
# ERISIAN KLOCK ver 5:23.05
# being an Implementation of Discordian Time Specification (1),
# an extension to the Principia Discordia wrought by
# m'Eniac, Lord Fuddlemeister of the Cloned Synapse
# on SweetMorn, day 28 of Confusion, 3163. (k) General Frenetics, Discorp.
# 	http://www.lodz.pdi.net/~eristic/erisware.html
# 	http://come.to/fnord/
# 	eristic@lodz.pdi.net
# --------------------------------------------------------------------------
# This program is Fnordware. Use it or lose it. If ingested, do not induce
# vomiting. May be harmful to house pets. No preservatives added. Percolate.
# --------------------------------------------------------------------------
# The script is a Perl port of a Turbo Pascal program I first did.
# If you want to copy it, you will need to set the $Time_Zone variable
# to correct time zone for the location of the machine that runs the
# script (it's a value relative to GMT/UTC time, range -12..12)
# SEE ALSO the variable $Trust_OS .
# --------------------------------------------------------------------------
# Also available:
# DOS version: http://www.lodz.pdi.net/~eristic/klock.zip
# Win95 version: http://www.lodz.pdi.net/~eristic/klock_win.zip
# --------------------------------------------------------------------------
# 11-Oct-1998
# BUG!! Found and fearlessly examined by Ron Hale-Evans.
# Klock time was always off by 360 aneristic minutes between midnight
# and 05:00 (UTC). Reason: severe brain damage while figuring out
# the number of hours between 6 am and midnight.
# Fixed.
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# Initialize major global variables, Pascal style :)
# These are configurable options, some of which you will need to set.
# --------------------------------------------------------------------------

## $Img_Path
# Path to my homepage images directory: may be absolute or relative
# You can link to the images at the General Frenetics website, these are
# files "0.gif" to "9.gif" in "http://www.lodz.pdi.net/~eristic/img"
# directory; or you can put the images at your own server. The images
# ought to be included in the Perl distribution, please do not remove
# them when you share the Perl version of Klock.
# my $Img_Path = './img';
my $Img_Path = 'http://www.lodz.pdi.net/~eristic/img';

## $Klock_URL
# $Klock_URL is the full URL to the script as installed on the server.
# It is used to build the meta "refresh" tag (HTML) so that the browser
# will automatically update the Klock display.
my $Klock_URL = 'http://www.lodz.pdi.net/~eristic/klock.pl';

## $Output_HTML
# If $Output_HTML is set to true, the script will output HTML-formatted
# page for feeding to the browser. For debugging, however, it is much
# more convenient to have plain text output; to that end set $Output_HTML
# to false, and the script will run a different output routine.
my $Output_HTML = 1;

## $Trust_OS
# If $Trust_OS is set to true, we will use Perl's native
# gmtime() to get the UTC/GMT time directly, TRUST-ing
# that the machine which runs the script has time zone
# environment variable correctly set. If $Trust_OS is true
# (non-zero), the setting of $Time_Zone below has no
# effect. If $Trust_OS is set to false (zero), the
# $Time_Zone **must** be properly set by hand, for
# the specific location of the machine that runs this script.
# (BTW, the time output has nothing to do with the local time
# of the user who calls the script from his browser, trust me ;)
# Such is the way of Erisian Time Specification... Hail Eris!)
# (Also BTW. DOS machines usually do not have any time zone info...
# Unless you're using PGP which sorta wants the TZ env var set.
# Still, if you're trying this on a DOS port of perl, you're
# safer setting $Trust_OS to zero and explicitly setting the
# $Time_Zone.)
my $Trust_OS = 0;

## $Time_Zone
# TIME ZONE for the machine that runs the script,
# relative to GMT/UTC time (e.g. +2 for Poland where I am)
# This must be set to correct time zone, otherwise trouble.
# ALSO: the time zone setting must account for any other
# local quirks I cannot foresee, such as daylight saving time.
# Just find out the difference between the real current time
# at where you live and real current GMT time. It will help
# if you find out both facts simultaneously.
# This var has no meaning if $Trust_OS is used, above.
my $Time_Zone = 1;

## $Images
# $Images controls the HTML output. If set to false,
# the HTML code will display Klock time in plain text;
# otherwise the script will use images for 0..9 digits.
# There's a whole tangle of IF statements in the output routine,
# since we need slightly different tables in HTML depending on
# whether images are used or not.
my $Images = 1;

## Assorted HTML sugarcubes
# file name for the background image, colors for HTML output.
# Cleaner to set them apart here than to fish for them inside
# the HTPerlML jumble. Adjust to your tastes.
my $BG_IMAGE    = 'bg_ash.jpg';
my $BG_COLOR    = '#005555';
my $TEXT_COLOR  = '#FFFFBB';
my $LINK_COLOR  = '#FFFFCC';
my $VLINK_COLOR = '#FFFFFF';
my $ALINK_COLOR = '#00FF00';

# --------------------------------------------------------------------------
# Various run-time variables/flags initialized below.
# Nothing you need to set manually (things might break if you do).
# --------------------------------------------------------------------------

# What we will finally display
my $Klock_String = "";

# "Flavor"; Erisian Time Unit Specification permits as many as
# five time measurement systems. These are selected by the
# value called Flavor. Presently only 1 of the possible 5 systems
# is defined, so Flavor can only be equal to 1 and has no
# real meaning here. It will grow in meaning as the remaining
# systems are defined (see URL on top of this file for updates)
my $Flavor = 1;

# Current time in GMT/UTC time
# These are filled in in derive_utc_time subroutine.
my $UTC_Hour = 0;
my $UTC_Minute = 0;
my $UTC_Second = 0;

# local hour on the machine that runs the script
# Converted internally to UTC_Hour based on $Time_Zone
my $Local_Hour = 0;

# How many minutes have elapsed since 5:23 UTC
my $Minutes_Elapsed = 0;

# Erisian time values, we will build $Klock_String from these:
# These are filled in derive_klock_time
my $Klock_Hour = 0;
my $Klock_Minute = 0;
my $Klock_Second = 0;

# Are we in Thud (output a fair warning if we are)
my $In_Thud = 0;

# Duration of Thud, in minutes (this is a const., btw)
my $Thud_Duration = 115;

my $Flaming_Death = "CHOKE, GAG: Unsupported value of Flavor: $Flavor\n";

# --------------------------------------------------------------------------
# the main module.
# --------------------------------------------------------------------------

&derive_utc_time;
&derive_klock_time;

if ( $Output_HTML )
{
	&print_html;
}
else
{
	&print_text;
}


# --------------------------------------------------------------------------
# the various subprograms, in no special order.
# --------------------------------------------------------------------------
sub print_text
# NOTE: This display is meant to aid debugging. It's not meant to be pretty.
{
my $ThudStr = 'THUD       : ';

if ( $In_Thud ) {
	$ThudStr .=	'YES';
} else {
	$ThudStr .=	'NO';
}

print <<GOBBLEGOBBLEGOBBLE;
-------------------------------------------------
Erisian Klock ver 5.23.03
(k) General Frenetics, Discorp.
-------------------------------------------------
Time_Zone  : $Time_Zone
Local_Hour : $Local_Hour
UTC_Hour   : $UTC_Hour
UTC_Minute : $UTC_Minute
UTC_Second : $UTC_Second
Elapsed    : $Minutes_Elapsed minutes since 5:23
$ThudStr
-------------------------------------------------
KLOCK HOUR    : $Klock_Hour
KLOCK MINUTE  : $Klock_Minute
KLOCK SECOND  : $Klock_Second
KLOCK STRING  : $Klock_String
-------------------------------------------------
GOBBLEGOBBLEGOBBLE
} # print_text

sub print_html
{

my ( $character, $digit ); # ALL MINE!

# print "Content-type: text/html\n\n";
# (You may or may not need the above line, depending on your Web server configuration)
print <<WEB_BLAH;
<HTML><HEAD>
<TITLE>Discordian Klock ver 5.23 - the Ultimate Erisian Time Machine!</TITLE>
<META http-equiv="refresh" content="5; url=$Klock_URL">
</HEAD>
<BODY BACKGROUND="$Img_Path/$BG_IMAGE" BGCOLOR="$BG_COLOR" TEXT="$TEXT_COLOR" LINK="$LINK_COLOR" VLINK="$VLINK_COLOR" ALINK="$ALINK_COLOR">
<CENTER><H1 ALIGN=CENTER>Official Erisian Klock Measure:</H1>
<PRE>


</PRE>
<TABLE BORDER=5 ALIGN=CENTER CELLPADDING=1 WIDTH="90%">
WEB_BLAH

if ( $Images )
{
	print "<TR>\n<TD ALIGN=CENTER>\n";

	$character = "0";

	for ( $digit=1; $digit<=length( $Klock_String ); $digit++ )
	{
		$character = substr( $Klock_String, $digit-1, 1 );

		if ( $character eq "(" )
		{
			print "<IMG SRC=\"$Img_Path/left_paren.gif\" ALT=\"(\" WIDTH=30 HEIGHT=70 BORDER=0>";
		}
		elsif ( $character eq ")" )
		{
			print "<IMG SRC=\"$Img_Path/right_paren.gif\" ALT=\")\" WIDTH=30 HEIGHT=70 BORDER=0>";
		}
		elsif ( $character eq ":" )
		{
			print "<IMG SRC=\"$Img_Path/colon.gif\" ALT=\":\" WIDTH=50 HEIGHT=70 BORDER=0>";
		}
		else
		{
			print "<IMG SRC=\"$Img_Path/$character.gif\" ALT=\"$character\" WIDTH=50 HEIGHT=70 BORDER=0>";
		}
	}
	print "\n</TD>\n</TR>\n";
}
else
{
	print "<TABLE BORDER=9 ALIGN=CENTER CELLPADDING=5>\n";
	print "<TR><TD><FONT COLOR=\"#00FF00\"><BR><H1 ALIGN=CENTER>";
	print "$Klock_String";
	print " </H1></FONT></TD></TR>\n";
	print " </H1></FONT></TD></TR>\n";
}


if ( $In_Thud )
{
	print "<TR><TD><BR><H2 ALIGN=CENTER>";
	print "This is the hour of Thud!";
	print "</H2></TD></TR>\n";
}
print <<WEB_BLAH2;
</TABLE></CENTER>
<PRE>


</PRE>
<H4 ALIGN=CENTER>
[ <A HREF="http://www.lodz.pdi.net/~eristic/klock.html">Erisian Time Specification</A>
| <A HREF="http://www.lodz.pdi.net/~eristic/free/klock_perl.zip">Perl source</A>
| <A HREF="http://www.lodz.pdi.net/~eristic/erisware.html">Erisian Warez Server</A> ]
</H4>
</BODY></HTML>
WEB_BLAH2

} # print_html


sub derive_utc_time
{
my ( $mday,$mon,$year,$wday,$yday,$isdst );

	if ( $Trust_OS )
	{
		($UTC_Second,$UTC_Minute,$UTC_Hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time);
	}
	else
	{
	($UTC_Second,$UTC_Minute,$Local_Hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	my $delta = abs( $Time_Zone );
	if ( $Time_Zone == 0 )
	{
		$UTC_Hour = $Local_Hour;
	}
	elsif ( $Time_Zone > 0 )
	{
		if ( $Local_Hour >= $delta )
		{
		$UTC_Hour = $Local_Hour - $delta;
		}
		else
		{
			$UTC_Hour = 24-($delta-$Local_Hour);
		}
	}
	else
	{
		if (( $Local_Hour + $delta ) >= 24 )
		{
			$UTC_Hour = ( $Local_Hour + $delta ) - 24;
		}
		else
		{
			$UTC_Hour = ( $Local_Hour + $delta );
		}
	}
	}
} # derive_utc_time

sub elapsed_minutes
{
	my $tmp = 0;

	if (( $UTC_Hour == 5 ) && ( $UTC_Minute >= 23 ))
	{
		$tmp = $UTC_Minute-23;
	}
	elsif (( $UTC_Hour == 5 ) && ( $UTC_Minute < 23 ))
	{
		$tmp = 1440-(23-$UTC_Minute);
	}
	elsif ( $UTC_Hour > 5 )
	{
		$tmp = 37 + (((($UTC_Hour-5)-1)*60) + $UTC_Minute);
	}
	elsif ( $UTC_Hour < 5 )
	{
		$tmp = 37 + (18*60) + ($UTC_Hour*60) + $UTC_Minute;
	}
	return $tmp;
} # elapsed_minutes

sub derive_klock_time
{
	my $Minutes_Past_Thud;

	# see how many minutes have passed since 5:23
	# (which is the Official Beginning of an Erisian Day)
	$Minutes_Elapsed = &elapsed_minutes;

	# See if we are in the HOUR OF THUD
	if ( $Minutes_Elapsed <= $Thud_Duration )
	{
		$In_Thud = 1;
	}
	else
	{
		$In_Thud = 0;
	}

	# Now, finally, calculate the Erisian time value.

	# select which Flavor to use
	# (only Flavor(1) supported in this release)
	if ( $Flavor == 1 )
	{
		if ( $In_Thud )
		{
			$Klock_Hour = 0;
			$Klock_Minute = int( $Minutes_Elapsed / 23 );
			$Klock_Second = ( $Minutes_Elapsed % 23 );
		}
		else
		{
			$Minutes_Past_Thud = ( $Minutes_Elapsed - $Thud_Duration );
			$Klock_Hour = ( int( $Minutes_Past_Thud /  5 )) + 1;
			$Klock_Minute = ( $Minutes_Past_Thud % 5 );
			$Klock_Second = int( $UTC_Second / 12 );
		}
	}
	else
	{
		die $Flaming_Death;
	}

	# Now form the $Klock_String;
	# (This is totally unnecessary; we could as well feed the
	# numeric values... but this lets us add the leading zeros
	# in a most anal-retentive way possible.)

	if ( $Klock_Hour < 100 )
	{
		$Klock_String .= "0";
	}
	if ( $Klock_Hour < 10 )
	{
		$Klock_String .= "0";
	}
	$Klock_String .= $Klock_Hour;

	if ( $Output_HTML && !( $Images ))
	{
		$Klock_String = "$Klock_String<BLINK>\:</BLINK>"; # nasty
	}
	else
	{
		$Klock_String .= ":";
	}

	if ( $Klock_Minute < 10 )
	{
		$Klock_String .= "0";
	}

	$Klock_String .= $Klock_Minute;

	if ( $Output_HTML && !( $Images ))
	{
		$Klock_String = "$Klock_String<BLINK>\:</BLINK>";
	}
	else
	{
		$Klock_String .= ":";
	}


	if ( $Klock_Second < 10 )
	{
		$Klock_String .= "0";
	}

	$Klock_String .= $Klock_Second;

	if ( $Output_HTML && $Images )
	{
		# NOT adding the space char if we're showing images
		$Klock_String = "$Klock_String($Flavor)";
	}
	else
	{
		$Klock_String = "$Klock_String ($Flavor)";
	}

} # derive_klock_time

__END__

# --------------------------------------------------------------------------
# That's all, folks!
# --------------------------------------------------------------------------

